; Program : Indikator pre equalizer wEQ5 
; Pre     : Janka Andrejku wJA
; Napisal : Vladimir Visnovsky
; uP      : Atmega8535

; Mapa pinov
; PA2-PA7 : Analogve vstupy
; PA1     : Prepinac Funkcii
; PA0     : COMM 1
; PB0-PB3 : LED  1
; PC7     : COMM 2
; PB4-PB7 : LED  2
; PC6     : COMM 3
; PD0-PD3 : LED  3
; PC5     : COMM 4
; PD4-PD7 : LED  4
; PC4     : COMM 5
; PC0-PC3 : LED  5

; Madzne hodnoty
.Equ L1		= 5
.Equ L2		= 20
.Equ L3		= 50
.Equ L4		= 100
.Equ Over	= 128

.cseg

; Nacitanie kniznice
.Include "wMega.asm"


; Inicializacia AD prevodnika
 AD_Ref5V

; Nastavenie vystupov
 PortA_Init [0b00000001]
 PortA_Out  [0b00000010] 
 PortB_Init [0b11111111]
 PortC_Init [0b11111111] 
 PortD_Init [0b11111111] 


; Pridelenie registrov
.Def tPA   	= R26
.Def tPB   	= R27
.Def tPC   	= R28
.Def tPD   	= R29
.Def mAD1	= R0
.Def mAD2	= R1
.Def mAD3	= R2
.Def mAD4	= R3
.Def mAD5	= R4
.Def mAD6	= R5

; Odskok na hlavny program
 Rjmp App

; Makro konverzie
aAD_Convert:
 ; Makro z wMega.asm
 ; Vstup -> A
 ; Vystup-> A
 AD_Convert
 Ret
  ; Volanie bez parametra
 .Macro Read
  .Message "Read: Chyba parameter"
 .EndMacro
  ; Volanie z parametrom (1-6)
 .Macro Read_i_8_8
  Ldi A		, @0+1
  RCall aAD_Convert
  Ldi T		, 0
  Add @2	, A
  Adc @1	, T
 .EndMacro  


; Procedura Spracovanie meznej hodnoty
; A- Hodnota, B- Vystup (T=1 - cervena farba)
aLimit: 
 Cpi A		, L1
  Brlo aLimit_L0
 Cpi A		, L2
  Brlo aLimit_L1
 Cpi A		, L3
  Brlo aLimit_L2
 Cpi A		, L4
  Brlo aLimit_L3
 Cpi A		, Over
  Brlo aLimit_L4
 ; Prez hodnotu 
 Sbis PinA	, 1
  Rjmp aLimit_L4
  ; Level
  Ldi B 		, 0b00001111
  Rjmp aLimit_End
 ; Hodnota L0
 aLimit_L0:
  Ldi B 		, 0b00011111
  Rjmp aLimit_End
 ; Hodnota L1
 aLimit_L1:
  Brts aLimit_L1_r
  Ldi B 		, 0b00011110
  Rjmp aLimit_End
 aLimit_L1_r:
  Ldi B 		, 0b00000001
  Rjmp aLimit_End
 ; Hodnota L2
 aLimit_L2:
  Brts aLimit_L2_r
  Ldi B 		, 0b00011100
  Rjmp aLimit_End
 aLimit_L2_r:
  Ldi B 		, 0b00000011
  Rjmp aLimit_End
 ; Hodnota L3
 aLimit_L3:
  Brts aLimit_L3_r
  Ldi B 		, 0b00011000
  Rjmp aLimit_End
 aLimit_L3_r:
  Ldi B 		, 0b00000111
  Rjmp aLimit_End
 ; Hodnota L4
 aLimit_L4:
  Brts aLimit_L4_r
  Ldi B 		, 0b00010000
  Rjmp aLimit_End
 aLimit_L4_r:
  Ldi B 		, 0b00001111
  Rjmp aLimit_End
 ; Koniec procedury
 aLimit_End:
 Ret
.Macro Limit
 RCall aLimit
.EndMacro

   
; Odpocitanie
aSubTwo:
 Cp	  A		, B
  Brlo aST_Normal
  ; Odpocitanie opacne
  Sub A		, B
  Lsl A
  Set
 Ret  
 aST_Normal:
  Sub B		, A
  Mov A		, B
  Clt
 Ret
.Macro SubTwo
 RCall aSubTwo
.EndMacro

     
; Vykreslenie registrov   
aPrintCompare:  
 Ldi tPA	, 0b00000010
 ; Vykreslenie prveho
 Mov  A		, mAD1
 Mov  B		, mAD2
 SubTwo
 Limit
 Bst  B		, 4
 Bld  tPA	, 0
 Andi B		, 0x0F
 Mov  tPB	, B
 ; Vykreslenie prveho
 Mov  A		, mAD2
 Mov  B		, mAD3
 SubTwo
 Limit
 Bst  B		, 4
 Bld  tPC	, 7
 Andi B		, 0x0F
 Swap B
 Or   tPB	, B
 ; Vykreslenie tretieho
 Mov  A		, mAD3
 Mov  B		, mAD4
 SubTwo
 Limit
 Bst  B		, 4
 Bld  tPC	, 6
 Andi B		, 0x0F
 Mov  tPD	, B
 ; Vykreslenie stvrtej
 Mov  A		, mAD4
 Mov  B		, mAD5
 SubTwo
 Limit
 Bst  B		, 4
 Bld  tPC	, 5
 Andi B		, 0x0F
 Swap B
 Or   tPD	, B
 ; Vykreslenie stvrtej
 Mov  A		, mAD5
 Mov  B		, mAD6
 SubTwo
 Limit
 Bst  B		, 4
 Bld  tPC	, 4
 Andi B		, 0x0F
 Andi tPC	, 0xF0
 Or   tPC	, B
 ; Vykreslenie
 OUT PortA , tPA
 OUT PortB , tPB
 OUT PortC , tPC
 OUT PortD , tPD
 Ret
.Macro PrintCompare
 RCall aPrintCompare
.EndMacro  


; Vykreslenie registrov   
aPrintLevel: 
 Ldi tPA	, 0b00000010
 ; Vykreslenie prveho
 Mov  A		, mAD2
 Clt   
 Limit
 Ldi B	, 0b00010000
 Bst  B		, 4
 Bld  tPA	, 0
 Andi B		, 0x0F
 Mov  tPB	, B
 ; Vykreslenie prveho
 Mov  A		, mAD3
 Clt   
 Limit
 Bst  B		, 4
 Bld  tPC	, 7
 Andi B		, 0x0F
 Swap B
 Or   tPB	, B
 ; Vykreslenie tretieho
 Mov  A		, mAD4
 Clt   
 Limit
 Bst  B		, 4
 Bld  tPC	, 6
 Andi B		, 0x0F
 Mov  tPD	, B
 ; Vykreslenie stvrtej
 Mov  A		, mAD5
 Clt   
 Limit
 Bst  B		, 4
 Bld  tPC	, 5
 Andi B		, 0x0F
 Swap B
 Or   tPD	, B
 ; Vykreslenie stvrtej
 Mov  A		, mAD6
 Clt   
 Limit
 Bst  B		, 4
 Bld  tPC	, 4
 Andi B		, 0x0F
 Andi tPC	, 0xF0
 Or   tPC	, B
 ; Vykreslenie
 OUT PortA , tPA
 OUT PortB , tPB
 OUT PortC , tPC
 OUT PortD , tPD
 Ret
.Macro PrintLevel
 RCall aPrintLevel
.EndMacro  


; Procedura Spracovanie meznej hodnoty 8 bit vystup
.Equ L1d	= 12
.Equ L2d	= 14
.Equ L3d	= 20
.Equ L4d	= 50
.Equ L5d	= 80
.Equ L6d	= 100
.Equ L7d	= 130
.Equ L8d	= 200
.Equ Overd	= 225

; A- Hodnota, B- Vystup
aLimit2:
 Set 
 Cpi A		, L1d
  Brlo aLimit_L0d
 Cpi A		, L2d
  Brlo aLimit_L1d
 Cpi A		, L3d
  Brlo aLimit_L2d
 Cpi A		, L4d
  Brlo aLimit_L3d
 Cpi A		, L5d
  Brlo aLimit_L4d
 Cpi A		, L6d
  Brlo aLimit_L5d
 Cpi A		, L7d
  Brlo aLimit_L6d
 Cpi A		, L8d
  Brlo aLimit_L7d
 Cpi A		, Overd
  Brlo aLimit_L8d
 ; Prez hodnotu d
  Clt	
  Ldi B 		, 0b11111111
  Rjmp aLimit_Endd
 ; Hodnota L0
 aLimit_L0d:
  Ldi B 		, 0b11111111
  Rjmp aLimit_Endd
 ; Hodnota L1
 aLimit_L1d:
  Ldi B 		, 0b11111110
  Rjmp aLimit_Endd
 ; Hodnota L2
 aLimit_L2d:
  Ldi B 		, 0b11111100
  Rjmp aLimit_Endd
 ; Hodnota L3
 aLimit_L3d:
  Ldi B 		, 0b11111000
  Rjmp aLimit_Endd
 ; Hodnota L4
 aLimit_L4d:
  Ldi B 		, 0b11110000
  Rjmp aLimit_Endd
 ; Hodnota L5
 aLimit_L5d:
  Ldi B 		, 0b11100000
  Rjmp aLimit_Endd
 ; Hodnota L6
 aLimit_L6d:
  Ldi B 		, 0b11000000
  Rjmp aLimit_Endd
 ; Hodnota L7
 aLimit_L7d:
  Ldi B 		, 0b10000000
  Rjmp aLimit_Endd
 ; Hodnota L8
 aLimit_L8d:
  Ldi B 		, 0b00000000
  Rjmp aLimit_Endd
 ; Koniec procedury
 aLimit_Endd:
 Ret
.Macro Limit2
 RCall aLimit2
.EndMacro


; Vykreslenie registrov   
aPrintLevel2:  
 Ldi tPA	, 0b00000010
 ; Vykreslenie prveho+druheho
 Mov  A		, mAD6
 Limit2
 Bld  tPA	, 0
 Bld  tPC	, 7
 Swap B
 Mov  tPB	, B
 ; Vykreslenie tretieho 
 Clt
 Bld  tPC	, 6
 Ldi  B		, 0x00
 Mov  tPD	, B
 ; Vykreslenie stvrtej+piatej
 Mov  A		, mAD1
 Limit2
 Bld  tPC	, 5
 Bld  tPC	, 4
 ;Swap B
 Mov  A		, B
 Andi A		, 0xF0
 Or   tPD	, A
 Andi B		, 0x0F
 Andi tPC	, 0xF0
 Or   tPC	, B
 ; Vykreslenie
 OUT PortA , tPA
 OUT PortB , tPB
 OUT PortC , tPC
 OUT PortD , tPD
 Ret
.Macro PrintLevel2
 RCall aPrintLevel2
.EndMacro  

 
; Hlavny program
App:
 
 Ldi ZH		, 255
 Ldi T		, 0
 Mov R6		, T
 Mov R7		, T
 Mov R8		, T
 Mov R9		, T
 Mov R10	, T
 Mov R11	, T
 Mov R0		, T
 Mov R1		, T
 Mov R2		, T
 Mov R3		, T
 Mov R4		, T
 Mov R5		, T

 App_ReadLoop:

 ; Nacitanie hodnot z AD
 Read [1, mAD1, R6]
 Read [2, mAD2, R7]
 Read [3, mAD3, R8]
 Read [4, mAD4, R9]
 Read [5, mAD5, R10]
 Read [6, mAD6, R11]
 
 Dec ZH
 Brne App_ReadLoop 
 
 ; Zistenie stavu prepinaca
 ; - 1- Level , 0- Compare
  Sbis PinA	, 1
   Rjmp App_Compare
 ; LEVEL
 App_Level:
  ;PrintLevel
  PrintLevel2
 Rjmp App

 ; Compare
 App_Compare:
  PrintCompare
 Rjmp App


